//Function: NumToBase
//Usage: NumToBase(Number (Between 0 and 73), Number (Between 2 and 73));
//Purpose: To convert a number from a decimal base to a single Charachter in another base.
//Comments: It took a bit to figure out how to make it without cases.
function numToBase(%a, %b)
{
	if(%a >= %b || %b > 73 || %b < 2) //Exception checking (You can't have base 0 or 1!)
		return -1;
	return getSubStr("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*()[];',./<>?", %a, 1);
}

//Function: BaseCharToDec
//Usage: BaseCharToDec(Number or Letter (Assumed to be a charachter in another base));
//Purpose: To convert a single base digit to a decimal base.
//Comments: It took a bit to figure out how to make it without cases.
function BaseCharToDec(%a)
{
	%b = "00 11 22 33 44 55 66 77 88 99 A10 B11 C12 D13 E14 F15 G16 H17 I18 J19 K20 L21 22 N23 O24 P25 Q26 R27 S28 T29 U30 V31 W32 X33 Y34 Z35 a36 b37 c38 d39 e40 f41 g42 h43 i44 45 k46 l47 m48 n49 o50 p51 q52 r53 s54 t55 u56 v57 w58 x59 y60 z61 +62 /63 @64 #65 $66 67 &68 ?69 <70 >71 !72";
	%c = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/@#$%&?<>!";
	%d = strPos(%b, getWord(%b, strPos(%c, %a)));
	return getSubStr(%b, %d + 1, %d > 9 ? 2 : 1);
}

//Function: IntDivide
//Usage: IntDivide(Number, Number);
//Purpose: To get the quotient and remainder of a into b.
function intDivide(%a, %b)
{
	return mFloor(%b / %a) SPC %b % %a;
}

//Function: DecToBase
//Usage: DecToBase(Decimal Number, Base to be converted to);
//Purpose: To convert a Decimal number into another base.
function DectoBase(%a, %b)
{
	while(%a - mPow(%b, %c) >= 0)
		%c++;
	%c--;
	for(%f = %c; %f >= 0; %f--)
	{
		%d = intDivide(mPow(%b, %f), %a);
		%e = %e @ numToBase(getWord(%d, 0), %b);
		%a = getWord(%d, 1);
	}
	return %e;
}

//Function: BaseToDec
//Usage: BaseToDec(Number in any base up to 73, Base of the number entered);
//Purpose: To convert a number in another base to a decimal base.
function BasetoDec(%a, %b)
{
	%d = -1;
	for(%c = strLen(%a) - 1; %c >= 0; %c--)
		%e += mPow(%b, %d++) * BaseCharToDec(getSubStr(%a, %c, 1));
	return %e;
}

//Function: BaseToBase
//Usage: BaseToBase(Number in Any Valid Base, Base of number entered, Base to Convert to);
//Purpose: To convert a number in any base to a different base.
function BaseToBase(%a, %b, %c)
{
	return DecToBase(BasetoDec(%a, %b), %c);
}

function fillOutHex(%a)
{
	if(strlen(%a) == 0)
		return "00";
	else if(strlen(%a) == 1)
		return "0" @ %a;
	else 
		return %a;
}
