registerInputEvent(fxDtsBrick,"onNewWinner","Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
$onNewWinnerEvent = inputEvent_GetInputEventIdx("onNewWinner");
registerInputEvent(fxDtsBrick,"onFall","Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");

function triggerOnNewWinner(%brick)
{
	$inputTarget_Self = %brick;
	$inputTarget_Player = $winnerClient.player;
	$inputTarget_Client = $winnerClient;
	$inputTarget_Minigame = getMinigameFromObject($winnerClient);
	%brick.processInputEvent("onNewWinner",$winnerClient);
}

function onNewWinner()
{
	for(%i=0;%i<getWordCount($newWinnerEventList);%i++)
	{
		%brick = getWord($newWinnerEventList,%i);
		if(isObject(%brick))
			triggerOnNewWinner(%brick);
	}
}

function fxDTSbrick::setPrintWinnerName(%this)
{
	%this.setPrintText($winnerName @ "         ");
}
registerOutputEvent("fxDTSbrick","setPrintWinnerName");

function fxDTSbrick::randomizeTileColors(%this)
{
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
		{
			%brick.setColor(getRandom($colorStart,$colorEnd));
		}
	}	
}
registerOutputEvent("fxDTSbrick","randomizeTileColors");

function revive(%this)
{
	if(!isObject(%this))
		return;
	%this.setRendering(1);
	%this.setRaycasting(1);
	%this.setColliding(1);
	if($fallingFX)
		%this.setColorFX(0);
	$fallingStarted = false;
}

function fxDTSBrick::fall(%this)
{
	%this.setRendering(0);
	%this.setRaycasting(0);
	%this.setColliding(0);
	schedule($fallTime,0,revive,%this);

	$inputTarget_Self = %this;
	$inputTarget_Player = $winnerClient.player;
	$inputTarget_Client = $winnerClient;
	$inputTarget_Minigame = getMinigameFromObject($winnerClient);
	%this.processInputEvent("onFall",$winnerClient);	
}

function glowBig(%fx)
{
	if(!$fallingFX)
		return;
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock $= "brickBigTileData")
				%brick.setColorFX(%fx);
	}
}

function fallBig()
{
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock !$= "brickBigTileData")
				%brick.fall();
	}
}

function glowNormal(%fx)
{
	if(!$fallingFX)
		return;
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock $= "brickNormalTileData")
				%brick.setColorFX(%fx);
	}
}

function fallNormal()
{
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock !$= "brickNormalTileData")
				%brick.fall();
	}
}

function glowSmall(%fx)
{
	if(!$fallingFX)
		return;
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock $= "brickSmallTileData")
				%brick.setColorFX(%fx);
	}
}

function fallSmall()
{
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock !$= "brickSmallTileData")
				%brick.fall();
	}
}

function glowTiny(%fx)
{
	if(!$fallingFX)
		return;
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock $= "brickTinyTileData")
				%brick.setColorFX(%fx);
	}
}

function fallTiny()
{
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock !$= "brickTinyTileData")
				%brick.fall();
	}
}

function glowGrill(%fx)
{
	if(!$fallingFX)
		return;
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock $= "brickGrillTileData")
				%brick.setColorFX(%fx);
	}
}

function fallGrill()
{
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.dataBlock !$= "brickGrillTileData")
				%brick.fall();
	}
}

function glowColor(%fx,%color)
{
	if(!$fallingFX)
		return;
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.colorID == %color)
				%brick.setColorFX(%fx);
	}
}

function fallColor(%color)
{
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			if(%brick.colorID != %color)
				%brick.fall();
	}
}

function commandtoplayers(%command,%arg1,%arg2,%arg3,%arg4)
{
	for(%a=0;%a<clientGroup.getCount();%a++)
	{
		%client = clientGroup.getObject(%a);
		if(isObject(%client.player))
		{
			if(%client.player.playing || %client.winner)
			{
				commandtoclient(%client,%command,%arg1,%arg2,%arg3,%arg4);
			}
		}
	}
}

function GameConnection::FallBig(%this)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	$fallingStarted = true;
	if($messageEveryone)
		commandtoall('centerPrint',"<color:FFFF00>Big tiles!",$prefallTime/1000);
	else
		commandtoplayers('centerPrint',"<color:FFFF00>Big tiles!",$prefallTime/1000);
	if($fallingFX)
		glowBig(4);
	$theFall = schedule($prefallTime,0,fallBig);
	schedule($prefallTime,0,glowBig,0);
}
registerOutputEvent("GameConnection","FallBig");

function GameConnection::FallNormal(%this)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	$fallingStarted = true;
	if($messageEveryone)
		commandtoall('centerPrint',"<color:FFFF00>Normal tiles!",$prefallTime/1000);
	else
		commandtoplayers('centerPrint',"<color:FFFF00>Normal tiles!",$prefallTime/1000);
	if($fallingFX)
		glowNormal(4);
	$theFall = schedule($prefallTime,0,fallNormal);	
	schedule($prefallTime,0,glowNormal,0);
}
registerOutputEvent("GameConnection","FallNormal");

function GameConnection::FallSmall(%this)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	$fallingStarted = true;
	if($messageEveryone)
		commandtoall('centerPrint',"<color:FFFF00>Small tiles!",$prefallTime/1000);
	else
		commandtoplayers('centerPrint',"<color:FFFF00>Small tiles!",$prefallTime/1000);
	if($fallingFX)
		glowSmall(4);
	$theFall = schedule($prefallTime,0,fallSmall);
	schedule($prefallTime,0,glowSmall,0);	
}
registerOutputEvent("GameConnection","FallSmall");

function GameConnection::FallTiny(%this)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	$fallingStarted = true;
	if($messageEveryone)
		commandtoall('centerPrint',"<color:FFFF00>Tiny tiles!",$prefallTime/1000);
	else
		commandtoplayers('centerPrint',"<color:FFFF00>Tiny tiles!",$prefallTime/1000);
	if($fallingFX)
		glowTiny(4);
	$theFall = schedule($prefallTime,0,fallTiny);
	schedule($prefallTime,0,glowTiny,0);	
}
registerOutputEvent("GameConnection","FallTiny");

function GameConnection::FallGrill(%this)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	$fallingStarted = true;
	if($messageEveryone)
		commandtoall('centerPrint',"<color:FFFF00>Grill tiles!",$prefallTime/1000);
	else
		commandtoplayers('centerPrint',"<color:FFFF00>Grill tiles!",$prefallTime/1000);
	if($fallingFX)
		glowGrill(4);
	$theFall = schedule($prefallTime,0,fallGrill);
	schedule($prefallTime,0,glowGrill,0);	
}
registerOutputEvent("GameConnection","FallGrill");

function GameConnection::FallColor(%this,%color,%name)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	$fallingStarted = true;
	%text = "";
	if(%name $= "")
		%text = "This color tiles!";
	else
		%text = %name SPC "colored tiles!";
	%floatcolor = getColorIDTable(%color);
	%r = mFloor(getWord(%floatcolor,0)*255);
	%g = mFloor(getWord(%floatcolor,1)*255);
	%b = mFloor(getWord(%floatcolor,2)*255);
	%code = fillOutHex(dectobase(%r,16)) @ fillOutHex(dectobase(%g,16)) @ fillOutHex(dectobase(%b,16));
	%text = "<color:" @ %code @ ">" @ %text;
	if($messageEveryone)
		commandtoall('centerPrint',%text,$prefallTime/1000);
	else
		commandtoplayers('centerPrint',%text,$prefallTime/1000);
	if($fallingFX)
		glowColor(4,%color);
	$theFall = schedule($prefallTime,0,fallColor,%color);
	schedule($prefallTime,0,glowBig,0,%color);
}
registerOutputEvent("GameConnection","FallColor","paintcolor 0" TAB "string 15 300");

function GameConnection::randomItems(%this,%item)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	%text = "<color:FFFF00>" @ %item.uiName @ "!";
	if($messageEveryone)
		commandtoall('centerPrint',%text,$prefallTime/1000);
	else
		commandtoplayers('centerPrint',%text,$prefallTime/1000);
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
		{
			if(getRandom(0,10) == 0)
				%brick.setItem(%item);
		}
	}
}
registerOutputEvent("GameConnection","randomItems","datablock ItemData");

function GameConnection::clearGameItems(%this)
{
	if($notYetOpen)
	{
		commandtoclient(%this,'centerPrint',"Wait for the round to start!",6);
		return;
	}
	if($fallingStarted)
	{
		commandtoclient(%this,'centerPrint',"You can't do two at the same time!",6);
		return;
	}
	%text = "<color:FFFF00>Items cleared!";
	if($messageEveryone)
		commandtoall('centerPrint',%text,$prefallTime/1000);
	else
		commandtoplayers('centerPrint',%text,$prefallTime/1000);
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
			%brick.setItem(0);
	}
	for(%a=0;%a<clientGroup.getCount();%a++)
	{
		%tclient = clientGroup.getObject(%a);
		if(isObject(%tclient.player))
		{
			if(%tclient.player.playing)
			{
				for(%b=0;%b<5;%b++)
				{
					messageClient(%tclient,'MsgItemPickup','',%b,0);
					%tclient.player.tool[%b] = 0;
				}
				servercmdunusetool(%tclient);
			}
		}
	}
}
registerOutputEvent("GameConnection","clearGameItems");

function Player::isInArena(%this)
{
	if(%this.client.winner)
		return;
	%this.playing = true;
}
registerOutputEvent("Player","isInArena");