function numLivingPlayers()
{
	%numplayers = 0;
	for(%a=0;%a<clientGroup.getCount();%a++)
	{
		%client = clientGroup.getObject(%a);
		if(isObject(%client.player))
			if(%client.player.playing)
				%numplayers++;
	}
	return %numplayers;
}

function openArena()
{
	$notYetOpen = false;
	messageall('',"<color:00FFFF>The next round has started!");
	commandtoall('centerPrint',"<color:00FFFF>The next round has started!",6);
	for(%a=0;%a<$gateBricks;%a++)
	{
		%brick = $gateBrick[%a];
		if(isObject(%brick))
		{
			%brick.setRendering(1);
			%brick.setRaycasting(1);
			%brick.setColliding(1);
		}
	}
}

function roundEnd()
{
	messageall('',"<color:00FFFF>The round went on for too long, restarting and choosing a random winner.");
	randomWinner();
}

function roundHalf()
{
	messageall('',"<color:00FFFF>The round is half over!");
}

function makeNewWinner(%winnerClient)
{
	if(!$FTilesEnabled)
	{
		echo("Falling tiles not enabled, killing action.");
		return;
	}

	if(isObject(%winnerClient))
		%winnerClient.incScore($scoreIncrease);
	for(%a=0;%a<$gateBricks;%a++)
	{
		%brick = $gateBrick[%a];
		if(isObject(%brick))
		{
			%brick.setRendering(0);
			%brick.setRaycasting(0);
			%brick.setColliding(0);
		}
	}
	cancel($theFall);
	for(%a=0;%a<$fallingTiles;%a++)
	{
		%brick = $fallingTile[%a];
		if(isObject(%brick))
		{
			%brick.setItem(0);
			revive(%brick);
		}
	}
	$notYetOpen = true;
	$winnerName = %winnerClient.name;
	$winnerClient = %winnerClient;
	for(%a=0;%a<clientGroup.getCount();%a++)
	{
		%client = clientGroup.getObject(%a);
		if(%client.winner)
		{
			%client.winner = false;
			if(isObject(%client.player))
				%client.instantRespawn();
		}
		%client.winner = false;
	}
	messageall('',"<color:00FFFF>" @ %winnerClient.name @ "<color:FFFF00> won that round!");
	%winnerClient.player.playing = false;
	%winnerClient.winner = true;
	if(isObject(%winnerClient.player))
		%winnerClient.instantRespawn();
	onNewWinner();
	cancel($roundOpen);
	$roundOpen = schedule($betweenRoundTime,0,openArena);
	cancel($roundClose);
	$roundClose = schedule($roundTimeout*1000,0,roundEnd);
	cancel($roundHalfClose);
	$roundHalfClose = schedule(($roundTimeout*1000)/2,0,roundHalf);
}

function winnerCheck(%client)
{
	if(!isObject(%client))
		return;
	if(!isObject(%client.player))
		return;
	if(%client.winner)
		%client.player.position = $winnerSpawn.position;
}

function randomWinner()
{
	if(clientGroup.getCount() < 1)
	{
		makeNewWinner();
		return;
	}
	%newwin = getRandom(0,clientGroup.getCount()-1);
	makeNewWinner(clientGroup.getObject(%newwin));
}

package fallingTilesBuild
{
	function GameConnection::OnClientLeaveGame(%client)
	{
		%needNew = false;
		if(%client.winner)
		{
			%needNew = true;
			%client.winner = false;
		}
		Parent::onClientLeaveGame(%client);
		if(%needNew)
		{
			messageall('',"<color:FFFF00>The winner left the game, selecting a random winner!");
			schedule(1000,0,randomWinner);
		}
	}

	function fxDtsBrick::onLoadPlant(%brick)
	{
		Parent::onLoadPlant(%brick);

		if(%brick.dataBlock.fallingTile)
			addFallingTile(%brick);
	}

	function fxDtsBrick::onPlant(%brick)
	{
		Parent::onPlant(%brick);

		if($tilesFreePlant)
		{
			if(%brick.dataBlock.fallingTile)
				addFallingTile(%brick);
			return;
		}

		//if($lastloadedbrick == %brick)
		//	return;

		%owner = %brick.getgroup().client;

		if(%brick.dataBlock.fallingTile)
		{
			if(!(%owner.isAdmin || %owner.isSuperAdmin))
			{
				if(isObject(%owner))
					messageclient(%owner,'',"Sorry, you must be an admin to plant that.");
				%brick.killBrick();
			}
			else
				addFallingTile(%brick);
		}
		else if(%brick.dataBlock $= "brickWinnerSpawnData")
		{
			if(!(%owner.isAdmin || %owner.isSuperAdmin))
			{
				if(isObject(%owner))
					messageclient(%owner,'',"Sorry, you must be an admin to plant that.");
				%brick.killBrick();
			}
			else
			{
				$winnerSpawn = %brick;
				messageall('',"<color:FFFF00>New winner spawnpoint set.");
			}
		}
	}

	function GameConnection::OnDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		
		Parent::onDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc);
		if($notYetOpen)
			return;
		if(numLivingPlayers() == 1)
		{
			for(%a=0;%a<clientGroup.getCount();%a++)
			{
				%client = clientGroup.getObject(%a);
				if(isObject(%client.player))
					if(%client.player.playing)
						makeNewWinner(%client);
			}
		}
		else if(numLivingPlayers() == 0)
		{
			messageall('',"<color:FFFF00>Everyone died, selecting a random winner!");
			%newwin = getRandom(0,clientGroup.getCount()-1);
			makeNewWinner(clientGroup.getObject(%newwin));
		}
	}

	function gameconnection::spawnplayer(%a,%b,%c)
	{
		parent::spawnplayer(%a,%b,%c);
		schedule(100,0,winnerCheck,%a);
	}

	function serverCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4)
	{
		if(%input == $onNewWinnerEvent)
		{
			$newWinnerEventList = addItemToList($newWinnerEventList,%client.wrenchBrick);
		}
		return Parent::serverCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4);
	}

	function serverCmdClearEvents(%client)
	{
		if(hasItemOnList($newWinnerEventList,%client.wrenchBrick))
		{
			$newWinnerEventList = removeItemFromList($newWinnerEventList,%client.wrenchBrick);
		}
		Parent::serverCmdClearEvents(%client);
	}

	function fxDtsBrick::onDeath(%brick)
	{
		if(hasItemOnList($newWinnerEventList,%brick))
		{
			$newWinnerEventList = removeItemFromList($newWinnerEventList,%brick);
		}
		Parent::onDeath(%brick);
	}
};
activatepackage(fallingTilesBuild);